TDME
====

    - What is it?
        - ThreeDeeMiniEngine is a small 3d engine suited for small 3d games written in JAVA

    - What is already working
        - 3d engine
            - model parsing
                - WaveFront OBJ
                - DAE parsing with skinned meshes and animations
                    - animations
                        - requires baked matrices
                - requires triangulated meshes for now
                - materials support diffuse textures only for now
            - object transformations
                - scaling
                - rotation
                - translation
            - lighting via OpenGL
            - dynamic shadows
              - via shadow mapping
              - for diffuse/ambient lights
                - no specular lights yet
              - still some issues
                - for orthogonal light direction and face normals
                - multiple lights are not yet 100% perfect, but working
            - camera control
              - set up look from, look at, up vector can be computed
              - frustum culling
            - several managers to reuse ...
              - meshes
              - vbos
              - textures
            - rendering
        - physics
            - collision detection
                - sphere
                - capsule
                - axis aligned bounding boxes
                - oriented bounding boxes

    - What does it (still) lack
        - some dynamic shadow features
          - specular lights
          - multiple light/shadows are not 100% correctly blended together
        - maybe light maps for static lighting/shadowing of environment
        - environment support
          - treat environment separatly and not as objects
          - determine height of point on environment
          - create collision information from environment
          - i'll see what I like to do here ...
        - some feasable partition for large worlds like BSP, Quattrees or Octree algorithmn
        - physics
          - missing triangle as bounding "volume"

    - Technology
        - uses JOGL
        - platforms
            - Windows
            - Linux
            - Mac Os X
            - Android(not yet, but planned)

    - Links
        - http://alpha.drewke.net/trac/
        - http://drewke.net/dnwp/tdme/

    - References
        - "game physics - a practical introduction" / Kenwright
        - "real-time collision detection" / Ericson
        - the world wide web! thank you for sharing
