// based on http://fabiensanglard.net/shadowmapping/index.php, modified by me

uniform sampler2D textureUnit;
uniform float texturePixelWidth;
uniform float texturePixelHeight;

varying vec4 shadowCoord;

void main() {
	// do not process samples out of frustum
	if (shadowCoord.w == 0.0) discard;

	// determine visibility
	float visibility = 0.0;
	visibility+= texture2D(textureUnit, shadowCoord.xy + vec2(-texturePixelWidth, -texturePixelHeight)).z <= shadowCoord.z?0.5:1.0;
	visibility+= texture2D(textureUnit, shadowCoord.xy + vec2(+texturePixelWidth, -texturePixelHeight)).z <= shadowCoord.z?0.5:1.0;
	visibility+= texture2D(textureUnit, shadowCoord.xy + vec2(+texturePixelWidth, +texturePixelHeight)).z <= shadowCoord.z?0.5:1.0;
	visibility+= texture2D(textureUnit, shadowCoord.xy + vec2(-texturePixelWidth, +texturePixelHeight)).z <= shadowCoord.z?0.5:1.0;
	visibility = visibility / 4.0;

	// skip if not shadowed
	if (visibility == 1.0) discard;

	// return color to be blended with framebuffer
	gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0 - visibility);
}
