#version 330

// based on http://fabiensanglard.net/shadowmapping/index.php, modified by me

uniform sampler2D textureUnit;
uniform float texturePixelWidth;
uniform float texturePixelHeight;

in vec4 shadowCoord;

out vec4 outColor;

void main() {
	// do not process samples out of frustum
	if (shadowCoord.w == 0.0) discard;

	// determine visibility
	float visibility = 0.0;
	visibility+= texture(textureUnit, shadowCoord.xy + vec2(-texturePixelWidth, -texturePixelHeight)).x <= shadowCoord.z?0.5:1.0;
	visibility+= texture(textureUnit, shadowCoord.xy + vec2(+texturePixelWidth, -texturePixelHeight)).x <= shadowCoord.z?0.5:1.0;
	visibility+= texture(textureUnit, shadowCoord.xy + vec2(+texturePixelWidth, +texturePixelHeight)).x <= shadowCoord.z?0.5:1.0;
	visibility+= texture(textureUnit, shadowCoord.xy + vec2(-texturePixelWidth, +texturePixelHeight)).x <= shadowCoord.z?0.5:1.0;
	visibility = visibility / 4.0;

	// skip if not shadowed
	if (visibility == 1.0) discard;

	// return color to be blended with framebuffer
	outColor = vec4(0.0, 0.0, 0.0, 1.0 - visibility);
}
