#version 330

// based on http://fabiensanglard.net/shadowmapping/index.php, modified by me

layout (location = 0) in vec3 inVertex;
layout (location = 1) in vec3 inNormal;
layout (location = 2) in vec2 inTextureUV;

uniform mat4 depthBiasMVPMatrix;
uniform mat4 objectToScreenMatrix;

out vec4 shadowCoord;

void main() {
	shadowCoord = depthBiasMVPMatrix * vec4(inVertex, 1.0);
	shadowCoord = shadowCoord / shadowCoord.w;

	// compute gl position
	gl_Position = objectToScreenMatrix * vec4(inVertex, 1.0);
}
