package net.drewke.tdme.assets;

import java.io.File;
import java.io.FileInputStream;

import net.drewke.tdme.assets.textures.ImageIO;
import net.drewke.tdme.assets.textures.TGA;
import net.drewke.tdme.assets.textures.Texture;

/**
 * TextureLoader loader class
 * @author Andreas Drewke
 * @version $Id: 08349c7c83f15e7daf810b46e13806d264c0cd41 $
 */
public class TextureLoader {

	/**
	 * Loads a texture
	 * @param path
	 * @param fileName
	 * @return texture data instance or null
	 */
	public static Texture loadTexture(String path, String fileName) {
		FileInputStream fis = null;
		try {
			String _fileName = path + File.separator + fileName; 
			fis = new FileInputStream(_fileName);
			if (fileName.toLowerCase().endsWith(".tga")) {
				TGA textureData = new TGA(_fileName);
				textureData.loadImage(fis);
				return textureData;
			} else {
				ImageIO textureData = new ImageIO(_fileName);
				textureData.loadImage(fis);
				return textureData;
			}
		} catch (Exception exception) {
			return null;
		} finally {
			if (fis != null) {
				try { fis.close(); } catch (Exception closeException) {}
			}
		}
	}

}