package net.drewke.tdme.model;

/**
 * AnimationSetup
 * @author Andreas Drewke
 * @version $Id: 682864c1bbf4cb661593852c0c0d8e7401ae9dd2 $
 */
public class AnimationSetup {

	private String id;
	private int startFrame;
	private int endFrame;
	private int frames;
	private boolean loop;

	/**
	 * Public constructor
	 * @param id
	 * @param startFrame
	 * @param endFrame
	 */
	public AnimationSetup(String id, int startFrame, int endFrame, boolean loop) {
		this.id = id;
		this.startFrame = startFrame;
		this.endFrame = endFrame;
		this.frames = (endFrame - startFrame) + 1;
		this.loop = loop;
	}

	/**
	 * @return id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @return start frame
	 */
	public int getStartFrame() {
		return startFrame;
	}

	/**
	 * @return end frame
	 */
	public int getEndFrame() {
		return endFrame;
	}

	/**
	 * @return frames
	 */
	public int getFrames() {
		return frames;
	}

	/**
	 * @return looping enabled
	 */
	public boolean isLoop() {
		return loop;
	}

}