package net.drewke.tdme.model;

import java.util.Arrays;

/**
 * Color 4 definition
 * @author Andreas Drewke
 * @version $Id: e745b2a6014b8b5cccc8a792a6dda02a267688f1 $
 */
public class Color4 {

	private float[] data;

	/**
	 * Public constructor
	 * @param red
	 * @param green
	 * @param blue
	 * @param alpha
	 */
	public Color4(float r, float g, float b, float a) {
		data = new float[4];
		data[0] = r;
		data[1] = g;
		data[2] = b;
		data[3] = a;
	}

	/**
	 * Set up color
	 * @param red
	 * @param green
	 * @param blue
	 * @param alpha
	 */
	public void set(float r, float g, float b, float a) {
		data[0] = r;
		data[1] = g;
		data[2] = b;
		data[3] = a;
	}

	/**
	 * Sets up this color with given color
	 * @param color
	 */
	public void set(Color4 color) {
		this.data = color.data.clone();
	}

	/**
	 * @return rgba as float array 
	 */
	public float[] getArray() {
		return data;
	}

	/**
	 * @return red component
	 */
	public float getRed() {
		return data[0];
	}

	/**
	 * @param red component
	 */
	public void setRed(float red) {
		data[0] = red;
	}

	/**
	 * @return green component
	 */
	public float getGreen() {
		return data[1];
	}

	/**
	 * @param green component
	 */
	public void setGreen(float green) {
		data[1] = green;
	}

	/**
	 * @return blue component
	 */
	public float getBlue() {
		return data[2];
	}

	/**
	 * @param blue component
	 */
	public void setBlue(float blue) {
		data[2] = blue;
	}

	/**
	 * @return alpha component
	 */
	public float getAlpha() {
		return data[3];
	}

	/**
	 * @param alpha component
	 */
	public void setAlpha(float alpha) {
		data[3] = alpha;
	}

	/*
	 * (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "Color4 [data=" + Arrays.toString(data) + "]";
	}

}
