package net.drewke.tdme.model;

import net.drewke.tdme.math.Matrix3D;

/**
 * Joint / Bone
 * @author andreas.drewke
 */
public class Joint {

	private String groupId;
	private Matrix3D bindMatrix;

	/**
	 * Public constructor
	 * @param group id
	 * @param bind matrix
	 */
	public Joint(String groupId) {
		this.groupId = groupId;
		this.bindMatrix = new Matrix3D().identity();
	}

	/**
	 * Associated group or bone id
	 * @return group id
	 */
	public String getGroupId() {
		return groupId;
	}

	/**
	 * Bind matrix
	 * @return matrix
	 */
	public Matrix3D getBindMatrix() {
		return bindMatrix;
	}

	/**
	 * @return string representation
	 */
	public String toString() {
		return "Joint [groupId=" + groupId + ", bindMatrix=" + bindMatrix
				+ "]";
	}
	
}