package net.drewke.tdme.model;

import java.util.Arrays;

import net.drewke.tdme.math.Vector3D;

/**
 * Class representing a UV data
 * @author andreas.drewke
 * @version $Id: 197b5dcce1bff13a101b835922d37e8d78c9efd6 $
 */
public class TextureCoordinate {

	private float data[];

	/**
	 * Public constructor
	 * @param u
	 * @param v
	 */
	public TextureCoordinate(float u, float v) {
		data = new float[2];
		data[0] = u;
		data[1] = 1.0f - v;
	}

	/**
	 * @return U
	 */
	public float getU() {
		return data[0];
	}

	/**
	 * @return V
	 */
	public float getV() {
		return data[1];
	}

	/**
	 * @return texture data as array
	 */
	public float[] getArray() {
		return data;
	}

	/**
	 * Clones the texture coordinate
	 * @return new texture coordinate
	 */
	public TextureCoordinate clone() {
		return new TextureCoordinate(
			data[0],
			1.0f - data[1] 
		);
	}

	/**
	 * @return string representation
	 */
	public String toString() {
		return Arrays.toString(data);
	}

}