package net.drewke.tdme.primitives;

import net.drewke.tdme.math.Vector3D;

/**
 * Plane
 * @author Andreas Drewke
 * @version $Id: e4ec2fe8b2d11dee1c604bc233ceaa447272f0a8 $
 */
public class Plane {

	protected Vector3D normal;
	protected float distance;

	/**
	 * Public default constructor
	 */
	public Plane() {
		normal = new Vector3D();
		distance = 0f;
	}

	/**
	 * Public constructor
	 * @param normal
	 * @param distance
	 */
	public Plane(Vector3D normal, float distance) {
		this.normal = normal;
		this.distance = distance;
	}

	/**
	 * @return float distance from origin
	 */
	public float getDistance() {
		return distance;
	}

	/**
	 * Set up distance from origin
	 * @param distance
	 */
	public void setDistance(float distance) {
		this.distance = distance;
	}

	/**
	 * @return normal
	 */
	public Vector3D getNormal() {
		return normal;
	}

	/*
	 * (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "Plane [normal=" + normal + ", distance=" + distance + "]";
	}

}